import proxyAddr from 'proxy-addr';
import string from '@poppinss/utils/string';
export function defineConfig(config) {
    const normalizedConfig = {
        allowMethodSpoofing: false,
        trustProxy: proxyAddr.compile('loopback'),
        subdomainOffset: 2,
        generateRequestId: false,
        useAsyncLocalStorage: false,
        etag: false,
        jsonpCallbackName: 'callback',
        cookie: {
            maxAge: '2h',
            path: '/',
            httpOnly: true,
            secure: false,
            sameSite: false,
        },
        qs: {
            parse: {
                depth: 5,
                parameterLimit: 1000,
                allowSparse: false,
                arrayLimit: 20,
                comma: true,
            },
            stringify: {
                encode: true,
                encodeValuesOnly: false,
                arrayFormat: 'indices',
                skipNulls: false,
            },
        },
        ...config,
    };
    if (normalizedConfig.cookie.maxAge) {
        normalizedConfig.cookie.maxAge = string.seconds.parse(normalizedConfig.cookie.maxAge);
    }
    return normalizedConfig;
}
