import { Exception } from '@poppinss/utils';
export class HttpException extends Exception {
    body;
    static code = 'E_HTTP_EXCEPTION';
    static invoke(body, status, code = 'E_HTTP_EXCEPTION') {
        if (body === null || body === undefined) {
            const error = new this('HTTP Exception', { status, code });
            error.body = 'Internal server error';
            return error;
        }
        if (typeof body === 'object') {
            const error = new this(body.message || 'HTTP Exception', { status, code });
            error.body = body;
            return error;
        }
        const error = new this(body, { status, code });
        error.body = body;
        return error;
    }
}
