import { Macroable } from '@poppinss/macroable';
import type { Application } from '@adonisjs/application';
import { Route } from './route.js';
import type { LazyImport } from '../types/base.js';
import type { MiddlewareStore } from '../middleware/store.js';
import type { MiddlewareAsClass } from '../types/middleware.js';
import type { MakeUrlOptions, RouteFn, RouteMatchers } from '../types/route.js';
export declare class BriskRoute<NamedMiddleware extends Record<string, LazyImport<MiddlewareAsClass>> = any> extends Macroable {
    #private;
    route: null | Route<NamedMiddleware>;
    constructor(app: Application, middlewareStore: MiddlewareStore<NamedMiddleware>, options: {
        pattern: string;
        globalMatchers: RouteMatchers;
    });
    setHandler(handler: RouteFn): Route;
    redirect(identifier: string, params?: any[] | Record<string, any>, options?: MakeUrlOptions): Route;
    redirectToPath(url: string): Route;
}
