export function execute(route, resolver, ctx) {
    return route.middleware
        .runner()
        .finalHandler(() => {
        if (typeof route.handler === 'function') {
            return route.handler(ctx);
        }
        return route.handler.handle(resolver, ctx);
    })
        .run((middleware, next) => {
        if (typeof middleware === 'function') {
            return middleware(ctx, next);
        }
        return middleware.handle(resolver, ctx, next, middleware.args);
    });
}
