import type Encryption from '@adonisjs/encryption';
import type { Qs } from '../../qs.js';
import { UrlBuilder } from './url_builder.js';
import type { RouteJSON } from '../../types/route.js';
export declare class LookupStore {
    #private;
    constructor(encryption: Encryption, qsParser: Qs);
    register(route: RouteJSON): void;
    builder(): UrlBuilder;
    builderForDomain(domain: string): UrlBuilder;
    find(routeIdentifier: string, domain?: string): RouteJSON | null;
    findOrFail(routeIdentifier: string, domain?: string): RouteJSON;
    has(routeIdentifier: string, domain?: string): boolean;
    toJSON(): {
        [domain: string]: RouteJSON[];
    };
}
