import { Macroable } from '@poppinss/macroable';
import type { Application } from '@adonisjs/application';
import { Route } from './route.js';
import type { LazyImport } from '../types/base.js';
import type { MiddlewareStore } from '../middleware/store.js';
import type { MiddlewareAsClass } from '../types/middleware.js';
import type { ResourceActionNames, RouteMatcher, RouteMatchers } from '../types/route.js';
export declare class RouteResource<NamedMiddleware extends Record<string, LazyImport<MiddlewareAsClass>> = any> extends Macroable {
    #private;
    routes: Route[];
    constructor(app: Application, middlewareStore: MiddlewareStore<NamedMiddleware>, options: {
        resource: string;
        controller: string;
        globalMatchers: RouteMatchers;
        shallow: boolean;
    });
    only(names: ResourceActionNames[]): this;
    except(names: ResourceActionNames[]): this;
    apiOnly(): this;
    where(key: string, matcher: RouteMatcher | string | RegExp): this;
    tap(callback: (route: Route<NamedMiddleware>) => void): this;
    tap(actions: ResourceActionNames | ResourceActionNames[], callback: (route: Route<NamedMiddleware>) => void): this;
    params(resources: {
        [resource: string]: string;
    }): this;
    as(name: string): this;
}
