import { Macroable } from '@poppinss/macroable';
import type { Application } from '@adonisjs/application';
import type { MiddlewareStore } from '../middleware/store.js';
import type { LazyImport, UnWrapLazyImport } from '../types/base.js';
import type { GetMiddlewareArgs, MiddlewareAsClass, MiddlewareFn } from '../types/middleware.js';
import type { RouteFn, RouteJSON, RouteMatcher, RouteMatchers, StoreRouteMiddleware } from '../types/route.js';
export declare class Route<NamedMiddleware extends Record<string, LazyImport<MiddlewareAsClass>> = any> extends Macroable {
    #private;
    constructor(app: Application, middlewareStore: MiddlewareStore<NamedMiddleware>, options: {
        pattern: string;
        methods: string[];
        handler: RouteFn | string;
        globalMatchers: RouteMatchers;
    });
    where(param: string, matcher: RouteMatcher | string | RegExp): this;
    prefix(prefix: string): this;
    domain(domain: string, overwrite?: boolean): this;
    middleware<Name extends keyof NamedMiddleware>(middleware: Name, ...args: GetMiddlewareArgs<UnWrapLazyImport<NamedMiddleware[Name]>>): this;
    middleware(middleware: MiddlewareFn): this;
    as(name: string, prepend?: boolean): this;
    isDeleted(): boolean;
    markAsDeleted(): void;
    getName(): string | undefined;
    getPattern(): string;
    setPattern(pattern: string): this;
    getMiddleware(): StoreRouteMiddleware[][];
    toJSON(): RouteJSON;
}
