import type { Constructor } from './base.js';
import type { RequestConfig } from './request.js';
import type { ResponseConfig } from './response.js';
import type { HttpContext } from '../http_context/main.js';
import { QSParserConfig } from './qs.js';
export type ServerErrorHandler = {
    handle: (error: any, ctx: HttpContext) => any;
};
export type ErrorHandlerAsAClass = Constructor<ServerErrorHandler>;
export type ServerConfig = RequestConfig & ResponseConfig & {
    useAsyncLocalStorage: boolean;
    qs: QSParserConfig;
};
